//
// This code is Copyright  2007 Colin Angus Mackay. All Rights Reserved.
// 
// This code was created for educational purposes, but it may be used on the 
// following conditions.
//
// 1. All copyright notices remain intact, including this one.
// 2. This license remains intact.
// 3. If the code is used in any software the copyright notice must be replicated
//    in the "About" box or equivalent location. i.e. anywhere the software's
//    copyright notice appears.
// 4. If the code is extracted into another assembly then the 
//    AssemblyCopyrightAttribute for the assembly must include the copyright 
//    notice "Parts of this software are Copyright  2007 Colin Angus Mackay."
// 5. This code is provided "AS IS" without warranty of any kind. You may use
//    the code only on the understanding that you use it at your own risk.
//
// For more information see http://www.colinmackay.net
//
using System;
using System.Collections.Generic;
using System.Text;

using NUnit.Framework;
using ColinAngusMackay.NumbersInWords;

namespace NumbersInWords.Test
{
    [TestFixture]
    public class EnglishTest
    {
        [Test]
        public void NumberToEnglishShouldReturnOne()
        {
            string actual = English.NumberToEnglish(1);
            Assert.AreEqual("one", actual, "Expected the result to be \"one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwo()
        {
            string actual = English.NumberToEnglish(2);
            Assert.AreEqual("two", actual, "Expected the result to be \"two\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnThree()
        {
            string actual = English.NumberToEnglish(3);
            Assert.AreEqual("three", actual, "Expected the result to be \"three\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFour()
        {
            string actual = English.NumberToEnglish(4);
            Assert.AreEqual("four", actual, "Expected the result to be \"four\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFive()
        {
            string actual = English.NumberToEnglish(5);
            Assert.AreEqual("five", actual, "Expected the result to be \"five\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSix()
        {
            string actual = English.NumberToEnglish(6);
            Assert.AreEqual("six", actual, "Expected the result to be \"six\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSeven()
        {
            string actual = English.NumberToEnglish(7);
            Assert.AreEqual("seven", actual, "Expected the result to be \"seven\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnEight()
        {
            string actual = English.NumberToEnglish(8);
            Assert.AreEqual("eight", actual, "Expected the result to be \"eight\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNine()
        {
            string actual = English.NumberToEnglish(9);
            Assert.AreEqual("nine", actual, "Expected the result to be \"nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTen()
        {
            string actual = English.NumberToEnglish(10);
            Assert.AreEqual("ten", actual, "Expected the result to be \"ten\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnEleven()
        {
            string actual = English.NumberToEnglish(11);
            Assert.AreEqual("eleven", actual, "Expected the result to be \"eleven\"");
        }
        
        [Test]
        public void NumberToEnglishShouldReturnTwelve()
        {
            string actual = English.NumberToEnglish(12);
            Assert.AreEqual("twelve", actual, "Expected the result to be \"twelve\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnThirteen()
        {
            string actual = English.NumberToEnglish(13);
            Assert.AreEqual("thirteen", actual, "Expected the result to be \"thirteen\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFourteen()
        {
            string actual = English.NumberToEnglish(14);
            Assert.AreEqual("fourteen", actual, "Expected the result to be \"fourteen\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFifteen()
        {
            string actual = English.NumberToEnglish(15);
            Assert.AreEqual("fifteen", actual, "Expected the result to be \"fifteen\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSixteen()
        {
            string actual = English.NumberToEnglish(16);
            Assert.AreEqual("sixteen", actual, "Expected the result to be \"sixteen\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSeventeen()
        {
            string actual = English.NumberToEnglish(17);
            Assert.AreEqual("seventeen", actual, "Expected the result to be \"seventeen\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnEighteen()
        {
            string actual = English.NumberToEnglish(18);
            Assert.AreEqual("eighteen", actual, "Expected the result to be \"eighteen\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNineteen()
        {
            string actual = English.NumberToEnglish(19);
            Assert.AreEqual("nineteen", actual, "Expected the result to be \"nineteen\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwenty()
        {
            string actual = English.NumberToEnglish(20);
            Assert.AreEqual("twenty", actual, "Expected the result to be \"twenty\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwentyOne()
        {
            string actual = English.NumberToEnglish(21);
            Assert.AreEqual("twenty one", actual, "Expected the result to be \"twenty one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwentyTwo()
        {
            string actual = English.NumberToEnglish(22);
            Assert.AreEqual("twenty two", actual, "Expected the result to be \"twenty two\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnThirty()
        {
            string actual = English.NumberToEnglish(30);
            Assert.AreEqual("thirty", actual, "Expected the result to be \"thirty\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnThirtyOne()
        {
            string actual = English.NumberToEnglish(31);
            Assert.AreEqual("thirty one", actual, "Expected the result to be \"thirty one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnThirtyNine()
        {
            string actual = English.NumberToEnglish(39);
            Assert.AreEqual("thirty nine", actual, "Expected the result to be \"thirty nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnForty()
        {
            string actual = English.NumberToEnglish(40);
            Assert.AreEqual("forty", actual, "Expected the result to be \"forty\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFortyOne()
        {
            string actual = English.NumberToEnglish(41);
            Assert.AreEqual("forty one", actual, "Expected the result to be \"forty one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFortyNine()
        {
            string actual = English.NumberToEnglish(49);
            Assert.AreEqual("forty nine", actual, "Expected the result to be \"forty nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFifty()
        {
            string actual = English.NumberToEnglish(50);
            Assert.AreEqual("fifty", actual, "Expected the result to be \"fifty\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFiftyOne()
        {
            string actual = English.NumberToEnglish(51);
            Assert.AreEqual("fifty one", actual, "Expected the result to be \"fifty one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFiftyNine()
        {
            string actual = English.NumberToEnglish(59);
            Assert.AreEqual("fifty nine", actual, "Expected the result to be \"fifty nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSixty()
        {
            string actual = English.NumberToEnglish(60);
            Assert.AreEqual("sixty", actual, "Expected the result to be \"sixty\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSixtyOne()
        {
            string actual = English.NumberToEnglish(61);
            Assert.AreEqual("sixty one", actual, "Expected the result to be \"sixty one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSeventy()
        {
            string actual = English.NumberToEnglish(70);
            Assert.AreEqual("seventy", actual, "Expected the result to be \"seventy\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSeventyOne()
        {
            string actual = English.NumberToEnglish(71);
            Assert.AreEqual("seventy one", actual, "Expected the result to be \"seventy one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnEighty()
        {
            string actual = English.NumberToEnglish(80);
            Assert.AreEqual("eighty", actual, "Expected the result to be \"eighty\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnEightyOne()
        {
            string actual = English.NumberToEnglish(81);
            Assert.AreEqual("eighty one", actual, "Expected the result to be \"eighty one\"");
        }


        [Test]
        public void NumberToEnglishShouldReturnNinety()
        {
            string actual = English.NumberToEnglish(90);
            Assert.AreEqual("ninety", actual, "Expected the result to be \"ninety\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNinetyOne()
        {
            string actual = English.NumberToEnglish(91);
            Assert.AreEqual("ninety one", actual, "Expected the result to be \"ninety one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneHundred()
        {
            string actual = English.NumberToEnglish(100);
            Assert.AreEqual("one hundred", actual, "Expected the result to be \"one hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneHundredAndOne()
        {
            string actual = English.NumberToEnglish(101);
            Assert.AreEqual("one hundred and one", actual, "Expected the result to be \"one hundred and one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneHundredAndFifteen()
        {
            string actual = English.NumberToEnglish(115);
            Assert.AreEqual("one hundred and fifteen", actual, "Expected the result to be \"one hundred and fifteen\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneHundredAndFiftyFive()
        {
            string actual = English.NumberToEnglish(155);
            Assert.AreEqual("one hundred and fifty five", actual, "Expected the result to be \"one hundred and fifty five\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneHundredAndNinetyNine()
        {
            string actual = English.NumberToEnglish(199);
            Assert.AreEqual("one hundred and ninety nine", actual, "Expected the result to be \"one hundred and ninty nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoHundred()
        {
            string actual = English.NumberToEnglish(200);
            Assert.AreEqual("two hundred", actual, "Expected the result to be \"two hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoHundredAndOne()
        {
            string actual = English.NumberToEnglish(201);
            Assert.AreEqual("two hundred and one", actual, "Expected the result to be \"two hundred and one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoHundredAndTwelve()
        {
            string actual = English.NumberToEnglish(212);
            Assert.AreEqual("two hundred and twelve", actual, "Expected the result to be \"two hundred and twelve\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoHundredAndSixtyThree()
        {
            string actual = English.NumberToEnglish(263);
            Assert.AreEqual("two hundred and sixty three", actual, "Expected the result to be \"two hundred and sixty three\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoHundredAndNintyNine()
        {
            string actual = English.NumberToEnglish(299);
            Assert.AreEqual("two hundred and ninety nine", actual, "Expected the result to be \"two hundred and ninety nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnThreeHundred()
        {
            string actual = English.NumberToEnglish(300);
            Assert.AreEqual("three hundred", actual, "Expected the result to be \"three hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFourHundred()
        {
            string actual = English.NumberToEnglish(400);
            Assert.AreEqual("four hundred", actual, "Expected the result to be \"four hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFiveHundred()
        {
            string actual = English.NumberToEnglish(500);
            Assert.AreEqual("five hundred", actual, "Expected the result to be \"five hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSixHundred()
        {
            string actual = English.NumberToEnglish(600);
            Assert.AreEqual("six hundred", actual, "Expected the result to be \"six hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnSevenHundred()
        {
            string actual = English.NumberToEnglish(700);
            Assert.AreEqual("seven hundred", actual, "Expected the result to be \"seven hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnEightHundred()
        {
            string actual = English.NumberToEnglish(800);
            Assert.AreEqual("eight hundred", actual, "Expected the result to be \"eight hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNineHundred()
        {
            string actual = English.NumberToEnglish(900);
            Assert.AreEqual("nine hundred", actual, "Expected the result to be \"nine hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNineHundredAndNinetyNine()
        {
            string actual = English.NumberToEnglish(999);
            Assert.AreEqual("nine hundred and ninety nine", actual, "Expected the result to be \"nine hundred and ninety nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneThousand()
        {
            string actual = English.NumberToEnglish(1000);
            Assert.AreEqual("one thousand", actual, "Expected the result to be \"one thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneThousandAndOne()
        {
            string actual = English.NumberToEnglish(1001);
            Assert.AreEqual("one thousand and one", actual, "Expected the result to be \"one thousand and one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneThousandOneHundred()
        {
            string actual = English.NumberToEnglish(1100);
            Assert.AreEqual("one thousand one hundred", actual, "Expected the result to be \"one thousand one hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoThousand()
        {
            string actual = English.NumberToEnglish(2000);
            Assert.AreEqual("two thousand", actual, "Expected the result to be \"two thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoThousandAndOne()
        {
            string actual = English.NumberToEnglish(2001);
            Assert.AreEqual("two thousand and one", actual, "Expected the result to be \"two thousand and one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoThousandOneHundred()
        {
            string actual = English.NumberToEnglish(2100);
            Assert.AreEqual("two thousand one hundred", actual, "Expected the result to be \"two thousand one hundred\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnThreeThousand()
        {
            string actual = English.NumberToEnglish(3000);
            Assert.AreEqual("three thousand", actual, "Expected the result to be \"three thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFourThousand()
        {
            string actual = English.NumberToEnglish(4000);
            Assert.AreEqual("four thousand", actual, "Expected the result to be \"four thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFiveThousand()
        {
            string actual = English.NumberToEnglish(5000);
            Assert.AreEqual("five thousand", actual, "Expected the result to be \"five thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNineThousandNineHundredAndNinetyNine()
        {
            string actual = English.NumberToEnglish(9999);
            Assert.AreEqual("nine thousand nine hundred and ninety nine", actual, "Expected the result to be \"nine thousand nine hundred and ninety nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTenThousand()
        {
            string actual = English.NumberToEnglish(10000);
            Assert.AreEqual("ten thousand", actual, "Expected the result to be \"ten thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTenThousandAndOne()
        {
            string actual = English.NumberToEnglish(10001);
            Assert.AreEqual("ten thousand and one", actual, "Expected the result to be \"ten thousand and one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnFifteenThousand()
        {
            string actual = English.NumberToEnglish(15000);
            Assert.AreEqual("fifteen thousand", actual, "Expected the result to be \"fifteen thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNineteenThousand()
        {
            string actual = English.NumberToEnglish(19000);
            Assert.AreEqual("nineteen thousand", actual, "Expected the result to be \"nineteen thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNineteenThousandNineHundredAndNinetyNine()
        {
            string actual = English.NumberToEnglish(19999);
            Assert.AreEqual("nineteen thousand nine hundred and ninety nine", actual, "Expected the result to be \"nineteen thousand nine hundred and ninety nine\"");
        }        

        [Test]
        public void NumberToEnglishShouldReturnNintyNineThousand()
        {
            string actual = English.NumberToEnglish(99000);
            Assert.AreEqual("ninety nine thousand", actual, "Expected the result to be \"ninety nine thousand\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNintyNineThousandNineHundredAndNinetyNine()
        {
            string actual = English.NumberToEnglish(99999);
            Assert.AreEqual("ninety nine thousand nine hundred and ninety nine", actual, "Expected the result to be \"ninety nine thousand nine hundred and ninty nine\"");
        }
    
        [Test]
        public void NumberToEnglishShouldReturnNineHundredAndNintyNineThousandNineHundredAndNinetyNine()
        {
            string actual = English.NumberToEnglish(999999);
            Assert.AreEqual("nine hundred and ninety nine thousand nine hundred and ninety nine", actual, "Expected the result to be \"nine hundred and ninety nine thousand nine hundred and ninty nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneMillion()
        {
            string actual = English.NumberToEnglish(1000000);
            Assert.AreEqual("one million", actual, "Expected the result to be \"one million\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneMillionAndOne()
        {
            string actual = English.NumberToEnglish(1000001);
            Assert.AreEqual("one million and one", actual, "Expected the result to be \"one million\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTenMillionAndTwenty()
        {
            string actual = English.NumberToEnglish(10000020);
            Assert.AreEqual("ten million and twenty", actual, "Expected the result to be \"ten million and twenty\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneHundredAndTwentyThreeMillionFourHundredAndFiftyNineThousdandSevenHundredAndEightyNine()
        {
            string actual = English.NumberToEnglish(123456789);
            Assert.AreEqual("one hundred and twenty three million four hundred and fifty six thousand seven hundred and eighty nine",
                actual, "Expected the result to be \"one hundred and twenty three million four hundred and fifty six thousand seven hundred and eighty nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNineHundredAndNintyNineMillionNineHundredAndNintyNineThousandNineHundredAndNintyNine()
        {
            string actual = English.NumberToEnglish(999999999);
            Assert.AreEqual("nine hundred and ninety nine million nine hundred and ninety nine thousand nine hundred and ninety nine",
                actual, "Expected the result to be \"nine hundred and ninety nine million nine hundred and ninety nine thousand nine hundred and ninety nine\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneBillion()
        {
            string actual = English.NumberToEnglish(1000000000);
            Assert.AreEqual("one billion", actual, "Expected the result to be \"one billion\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneBillionAndOne()
        {
            string actual = English.NumberToEnglish(1000000001);
            Assert.AreEqual("one billion and one", actual, "Expected the result to be \"one billion and one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnOneBillionOneMillion()
        {
            string actual = English.NumberToEnglish(1001000000);
            Assert.AreEqual("one billion one million", actual, "Expected the result to be \"one billion one million\"");
        }
        
        [Test]
        public void NumberToEnglishShouldReturnTwoBillion()
        {
            string actual = English.NumberToEnglish(2000000000);
            Assert.AreEqual("two billion", actual, "Expected the result to be \"two billion\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnTwoBillionOneHundredAndFortySevenMillionFourHundredAndEightyThreeThousandSixHundredAndFortySeven()
        {
            string actual = English.NumberToEnglish(int.MaxValue);
            Assert.AreEqual("two billion one hundred and forty seven million four hundred and eighty three thousand six hundred and forty seven",
                actual, "Expected the result to be \"two billion one hundred and forty seven million four hundred and eighty three thousand six hundred and forty seven\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnZero()
        {
            string actual = English.NumberToEnglish(0);
            Assert.AreEqual("zero", actual, "Expected the result to be \"zero\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNegativeOne()
        {
            string actual = English.NumberToEnglish(-1);
            Assert.AreEqual("negative one", actual, "Expected the result to be \"negative one\"");
        }

        [Test]
        public void NumberToEnglishShouldReturnNegativeTwoBillionOneHundredAndFortySevenMillionFourHundredAndEightyThreeThousandSixHundredAndFortyEight()
        {
            string actual = English.NumberToEnglish(int.MinValue);
            Assert.AreEqual("negative two billion one hundred and forty seven million four hundred and eighty three thousand six hundred and forty eight",
                actual, "Expected the result to be \"negative two billion one hundred and forty seven million four hundred and eighty three thousand six hundred and forty eight\"");
        }
    }
}
